// ドキュメントを読み込む
// var __loaderStack = new Array(); // loaders
// var __processing = false;        // mutex lock

function createHttpRequest() {
    if ( window.ActiveXObject ) {
        try {
            return new ActiveXObject( "Msxml2.XMLHTTP" );
        } catch ( e ) {
            return ActiveXObject( "Microsoft.XMLHTTP" );
        }
    }
    return new XMLHttpRequest();
}

function SiteLoader( url, parser, errorHandler, owner, method, data ) {
//function SiteLoader( url, parser, owner, method, data ) {
    //debug( "url = " + url + ", parser = " + parser );
    this.url = url;
    this.parser = parser;
    this.owner = owner;
    this.errorHandler = errorHandler;
    if ( method ) {
        this.method = method;
    } else {
        this.method = "GET";
    }
    if ( data ) {
        this.data = data;
    } else {
        this.data = data;
    }
    this.async = true;
    this.running = false;
    this.request = createHttpRequest();
    this.request.parser = parser;
    this.request.loader = this;
    this.start = _SiteLoader__start;
    this.abort = _SiteLoader__abort;
    //this.abort = _SiteLoader__setXML;

    this.xml = false;
}

// static variables
SiteLoader.prototype.__loaderStack = new Array();
SiteLoader.prototype.__processing = false;
SiteLoader.prototype.existsRunningProcess = function() {
    //debug( "rest processes " + SiteLoader.prototype.__loaderStack.length );
    if ( SiteLoader.prototype.__loaderStack.length == 0 ) return false;
    for ( var i = 0; i < SiteLoader.prototype.__loaderStack.length; i++ ) {
        if ( SiteLoader.prototype.__loaderStack[ i ].running ) {
            return false;
        }
    }
    return true;
//     return ( SiteLoader.prototype.__loaderStack.length > 0 );
}
function _SiteLoader__processContents() {
    //debug( "_SiteLoader__processContents" );
    //if ( __processing ) {
    if ( SiteLoader.prototype.__processing ) {
        setTimeout( _SiteLoader__processContents, 100 );
        return;
    }
    SiteLoader.prototype.__processing = true;
    for ( var i = SiteLoader.prototype.__loaderStack.length - 1; i >= 0; i-- ) {
        var loader  = SiteLoader.prototype.__loaderStack[ i ];
        var request = loader.request;
        var state = request.readyState;
        var status = request.status;
        if ( state == 4 ) {
            if ( status == 200 ) { // OK
                loader.running = false;
                SiteLoader.prototype.__loaderStack.splice( i, 1 );
                if ( loader.parser ) {
                    try { 
                        if ( loader.xml ) {
                            var xmldoc = request.responseXML;
                            loader.parser( xmldoc, loader.owner );
                        } else {
                            var text = request.responseText;
                            loader.parser( text, loader.owner );
                        }
                    } catch ( e ) {
                        debug( "caught in parsing : " + e );
//                        debug( "loader " + loader );
                        throw e;
//                     debug( loader.parser );
//                     debug( loader.owner );
                    }
                }
            } else {
                debug( "imcomplete : status = " + status );
                if ( loader.errorHandler ) {
                    loader.errorHandler( "Load failed" );
                }
            }
            loader.running = false;
        }
    }
    SiteLoader.prototype.__processing = false;
}

SiteLoader.prototype.abortAll = function() {
    for ( var i = 0; i < SiteLoader.prototype.__loaderStack.length - 1; i++ ) {
        var loader  = SiteLoader.prototype.__loaderStack[ i ];
        if ( loader.running ) {
            loader.abort();
        }
    }
}

function _SiteLoader__start() {
    //debug( "start loading" );
    SiteLoader.prototype.__loaderStack.push( this );
    this.request.open( this.method, this.url, this.async );
    this.request.onreadystatechange = _SiteLoader__processContents;
    this.request.send( this.data );
    this.running = true;
}

function _SiteLoader__abort() {
    this.request.abort();
    for ( var i = SiteLoader.prototype.__loaderStack.length; i >= 0; i-- ) {
        var loader = SiteLoader.prototype.__loaderStack[ i ];
        if ( loader == this.request ) {
            loader.running = false;
            loader.request.abort();
            SiteLoader.prototype.__loaderStack.splice( i, 1 );
            break;
        }
    }
}

function _SiteLoader__setXML( flag ) {
    this.xml = flag;
}
